<script lang="ts">
    /**
     * The panel with information and actions about the selected field.
     */
    import Illustration from './FieldPanel/Illustration.svelte'
    import Details from './FieldPanel/Details.svelte'
    import Summary from './FieldPanel/Summary.svelte'
    import UpgradeSummary from './FieldPanel/UpgradeSummary.svelte'
    import DistrictField from 'models/DistrictField'
    import Building from 'models/Building'
    import Footer from './FieldPanel/Footer.svelte'
    import { createEventDispatcher } from 'svelte'
    import EleriumAccelerator from 'models/Buildings/Resources/Production/EleriumAccelerator'
    import GraphiteMine from 'models/Buildings/Resources/Production/GraphiteMine'
    import GraphiteStorage from 'models/Buildings/Resources/Storage/GraphiteStorage'
    import HydroponicField from 'models/Buildings/Resources/Production/HydroponicField'
    import MetalMine from 'models/Buildings/Resources/Production/MetalMine'
    import EleriumStorage from 'models/Buildings/Resources/Storage/EleriumStorage'
    import MetalStorage from 'models/Buildings/Resources/Storage/MetalStorage'
    import PasteStorage from 'models/Buildings/Resources/Storage/PasteStorage'

    export let field: DistrictField
    export let isBuilding: boolean

    const dispatch = createEventDispatcher()
    const forwardNew = (building: Building) => {
        dispatch('newBuilding', {
            content: new building(),
        })
    }

    const availableBuildings: Building[] = [
        EleriumAccelerator,
        GraphiteMine,
        HydroponicField,
        MetalMine,
        EleriumStorage,
        GraphiteStorage,
        MetalStorage,
        PasteStorage,
    ]
</script>

{#if field.content === null}
    <div class="available">
        {#each availableBuildings as building}
            <div on:click={() => forwardNew(building)}>
                <Illustration name={building.name} />
            </div>
        {/each}
    </div>
{:else}
    <header>
        <figure>
            <Illustration name={field.content.name} />
        </figure>
        <div class="details">
            <Details {field} {isBuilding} />
        </div>
    </header>

    <Summary />

    {#if isBuilding}
        <UpgradeSummary building={field.content} />
    {/if}
{/if}

<Footer {isBuilding} building={field.content} on:cancel />

<style lang="postcss">
    .available {
        @apply grid grid-cols-2 gap-1;
    }
    header {
        @apply grid grid-cols-3 gap-1;
    }
    .details {
        @apply col-span-2;
    }
</style>
